<template>
  <div class="gris">
    <div class="divBuscador">
      <div>
        <v-text-field
          v-model="search"
          class="buscador"
          append-icon="mdi-magnify"
          label="Buscar..."
          single-line
          hide-details
        ></v-text-field>
      </div>
    </div>

    <v-data-table
      :headers="encabezadoHallazgos"
      :items="adicionales"
      :page.sync="page"
      :items-per-page="itemsPerPage"
      hide-default-footer
      @page-count="pageCount = $event"
      :search="search"
      class="tblGeneral tblHallazgos"
    >
      <template v-slot:item.status="{item}">
        <div
          :class="{
                borderV: item.status == 3,
                borderN: item.status == 0,
                borderN__light: item.status == 2,
                borderR: item.status == 1,
                }"
        >
          <span class="demi" v-if="item.status == 0">Rechazado por atender</span>
          <span class="demi" v-if="item.status == 1">Por atender</span>
          <span class="demi" v-if="item.status == 2">Por autorizar</span>
          <span class="demi" v-if="item.status == 3">Atendido</span>
        </div>
      </template>

      <template v-slot:item.action="{item}">
        <div       
        >
          <a class="liga" @click="idHallazgoSeleccionado = item.idHallazgo; dialogConfirmacion = true" >Convertir</a>
        </div>
      </template>
    </v-data-table>
    <div class="text-center pt-2">
      <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
    </div>

     <!--Confirmación de cambios Adicional-->
    <v-dialog v-model="dialogConfirmacion" max-width="600">
      <v-card>
        <v-card-title class="headline">
          <div class="titModal">Confirmación de Transformación</div>
        </v-card-title>
        <div class="contModal tCenter">
          <img src="@/assets/img/hallazgos/icoAlerta.svg" class="icoModal" />
          <div><strong>¿Deseas transformar este adicional en hallazgo?</strong><p>¡Una vez realizada esta acción no se podrá revertir.</p></div>

          <div class="btnCenter">
            <button
              type="button"
              class="btn btnG"
              text
              @click="dialogConfirmacion = false"
            >
              No, cancelar
            </button>
            <button
              type="button"
              class="btn"
              text
              @click="updateAdicional(); dialogConfirmacion = false"
            >
              Sí, convertir
            </button>
          </div>
        </div>
      </v-card>
    </v-dialog>

     <!--Confirmación de Error-->
    <v-dialog v-model="dialogError" max-width="600">
      <v-card>
        <v-card-title class="headline">
          <div class="titModal">Error</div>
        </v-card-title>
        <div class="contModal tCenter">
          <img src="@/assets/img/hallazgos/icoAlerta.svg" class="icoModal" />
          <div>No se pudo transformar a hallazgo. Intentalo nuevamente</div>
          <div class="btnCenter">
            <button
              type="button"
              class="btn btnG"
              text
              @click="dialogError = false; idHallazgoSeleccionado = 0"
            >
              Entendido
            </button>
            
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
export default {
  props: {
    idCeco: String,
    idFase: String,
    idProyecto: String
  },
  name: "tabla-adicionales",
  data() {
    return {
      idHallazgoSeleccionado : 0,
      dialogConfirmacion : false,
      dialogError : false,
      user: "",
      adicionales: [],
      page: 1,
      pageCount: 1,
      itemsPerPage: 10,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10]
      },
      encabezadoHallazgos: [
        //{ text: "Estatus", value: "status", align:  'center'  },
        { text: "Zona", value: "area", align: "center" },
        { text: "Protocolo", value: "nombChek", align: "center" },
        { text: "Item", value: "preg", align: "center" },
        { text: "Comentario", value: "obs", align: "center" },
        { text: "Transforma a hallazgo" , value: "action",  align: "center" }
        
      ]
    };
  },
  created() {
    this.getAdicionales();
    this.user = serviceLocalStorage.userToken();
  },
  methods: {
    updateAdicional(){

      
      axiosChecklist
        .get("expansionCoreServices/convierteAdicionalHallazgo.json?"+
            "idUsuario="+this.user.empleado+"&idHallazgo="+this.idHallazgoSeleccionado,
            {
              responseType: "json"
            }).then(response => {
              if(response){
                if(response.status === 200){
                  if(response.data.response === true){
                    this.dialogConfirmacion = false;
                    this.idHallazgoSeleccionado = 0
                    this.getAdicionales();
                    this.$emit('actualiza')
                  }else{
                    this.dialogError =  true;
                    this.idHallazgoSeleccionado = 0
                  }
                }
              }
            })
    },

    getAdicionales() {
      axiosChecklist
        .get(
          "expansionCoreServices/getAdicionalesCore.json?ceco=" +
            this.idCeco +
            "&proyecto=" +
            this.idProyecto +
            "&fase=" +
            this.idFase,
          {
            responseType: "json"
          }
        )
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.adicionales = response.data;
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    }
  }
};
</script>